#!/usr/bin/env node

import { NupstCli } from './cli.js';

/**
 * Main entry point for NUPST
 * Initializes the CLI and executes the given command
 */
async function main() {
  const cli = new NupstCli();
  await cli.parseAndExecute(process.argv);
}

// Run the main function and handle any errors
main().catch(error => {
  console.error('Error:', error);
  process.exit(1);
});
